{$IFDEF VER70}
{$I Over.inc}
{$ENDIF}

unit timer;

interface

procedure time1;      { ⠩}

{$IFDEF __GPC__}
function time2r  : medint; { Real Time, ms }
function time2   : medint; { User Time, ms }
{$ELSE}
function time2:longint;  {⠭ ⠩   ६  ᪠  ms}
{$ENDIF}

{$IFDEF VER70}
procedure SetTimer(F:real); {⠭  뢠 ⠩ 12..65535,
                              㬮砭 18.2}
{$ENDIF}

implementation

{$IFDEF VER70}
const
  Frec_of_Timer=1193180;
  defaultf=$ffff;
  Count_of_Timer  : word = $ffff;
  KT = 54.9246551232839974;

var
    OldTimeLo, OldTimeHi : word;

procedure time1; assembler;

  asm
     mov        al,     $36
     out        $43,    al
     mov        ax,     0{[Count_of_Timer]}
     out        40h,    al
     mov        al,     ah
     out        40h,    al
     mov        ah,     0
     int        1ah
     mov        [OldTimeLo],dx
     mov        [OldTimeHi],cx
  end;

function time2:longint;

var
  Tic:longint;

begin
  asm
     mov        ah,     0
     int        1aH
     sub        dx,     [OldTimeLo]
     sbb        cx,     [OldTimeHi]
     mov        word ptr [tic], dx
     mov        word ptr [tic+2],cx
     {
     mov        al,     $36
     out        $43,    al
     mov        ax,     $0
     out        40h,    al
     mov        al,     ah
     out        40h,    al
     }
  end;
  time2:=round(Tic*KT);
end;

procedure SetTimer(F:real);

  var v:longint;

  begin
    v:= round(Frec_of_Timer/F);
    if v>$FFFF then Count_of_Timer:=$FFFF
    else if v>10000 then Count_of_Timer:=v
  end;
{$ENDIF}

{$IFDEF FPC}
uses go32;

var OldTime:longint;

procedure Time1;

begin
  dosmemget ($40,$6c,OldTime,4) ;
end;

function Time2:longint;
var t2:longint;
begin
  dosmemget ($40,$6c,t2,4) ;
  Time2:=round((T2-OldTime)*54.9246551232839974);
end;
{$ENDIF}

{$IFDEF __TMT__}
const Seg0040=$40;
var
  T1,t2: longint;

procedure Time1;

begin
  t1 := memD[Seg0040:$6c];
  while t1=MemD[Seg0040:$6c] do; inc(t1);
end;

function Time2:longint;
begin
  t2 := memD[Seg0040:$6c];
  Time2:=round((t2-t1)*54.9246551232839974)
end;
{$ENDIF}

{$IFDEF VIRTUALPASCAL}
uses use32, windows;
var OldTime:longint;

procedure Time1;

begin
  OldTime:=GetTickCount;
end;

function Time2:longint;
begin
  Time2:=GetTickCount-OldTime;
end;
{$ENDIF}


{$IFDEF VER130}
uses Windows;

var OldTime:DWORD;
procedure Time1;
begin
  OLDTime:=GetTickCount();
end;

function Time2:longint;

begin
  Time2:=GetTickCount()-OLDTime;
end;
{$ENDIF}

{$IFDEF __GPC__}
type TMS = record
        tms_utime  : medint;    { User CPU time }
        tms_stime  : medint;    { System CPU time }
        tms_cutime : medint;    { User CPU time of terminated child procs }
        tms_cstime : medint;    { System CPU time of terminated child procs }
     end;

var Tstart : TMS;
    Trstart : medint;

function gettm(var T:TMS): medint; C; asmname 'times';

procedure time1;

begin
  Trstart:=GetTM(Tstart);
end;

function time2r: medint;

var T  : TMS;
    Tr : medint;

begin
  Tr:=GetTM(T);
  time2r:=medint((Tr-TrStart)*1000 div 91);
end;

function time2 : medint;

var T  : TMS;
    Tr : medint;

begin
  Tr:=GetTM(T);
  time2:=medint((T.tms_utime-TStart.tms_utime)*1000 div 91);
end;
{$ENDIF}

end.
